package algorithms;


import org.apache.bcel.classfile.*;
import org.apache.bcel.generic.*;
import java.io.*;
import java.util.*;
import org.apache.bcel.util.Class2HTML;



public class LoopUnroll {

	static FileInputStream fin;
    static BufferedReader din;
    static FileOutputStream fout;
	String forloop;
	Vector instrs = new Vector();

	public boolean apply(String classname) {

		ClassGen cgen = null;
		boolean sucess = false;

		try {


			String inPath = "C:/JHide/examples/" + classname + ".java";
			String outPath = "C:/JHide/engine/" + classname + ".java";

			loopUnroll(inPath,outPath);
			
			File file = new File("C:/JHide/engine/" + classname + ".java");
			
			copy("C:/JHide/engine/" + classname + ".java","C:/JHide/Obfuscated_Classes/examples/"+classname + "_obf"+".java");
			

			//JavaClass clazz = Repository.lookupClass("C:/JHide/engine/" + classname.trim());

			//clazz.dump(new java.io.File("C:/JHide/Obfuscated_Classes/",clazz.getClassName().replace('.', java.io.File.separatorChar) + "_obf" + ".class"));

			//convertToHTML(clazz,"Obf");

			sucess = true;

		}
	    catch(Exception e) {System.out.println("Exception" + e.getMessage()); return(sucess);}
		return(sucess);
	}


	 public void loopUnroll(String fileName,String outName) throws IOException{
	          int flag =0;
	          int i =0;

	 	      try {

	 	          fin = new FileInputStream(fileName);
	 	          din = new BufferedReader(new InputStreamReader(fin));

	 	          File writeFileObj = new File(outName);
	 	          fout = new FileOutputStream(writeFileObj);
	 	          String line;

	 	          while ((line = din.readLine()) != null) {
	 	                 line= line.trim();

	 	                 boolean match = line.trim().regionMatches(true,0,"for",0,2);
	 	                 if(match) {
	 						 forloop = line;
	 						 int index1 = forloop.indexOf("{");
	 						 forloop = forloop.substring(0,index1-1);
	 						 fout.write(forloop.getBytes());
	 						 flag =1;

	 				     }

						 else if(flag ==1) {
							 match = line.trim().regionMatches(true,0,"}",0,1);
							 if(match==false) {
	 					     	instrs.add(line);
	 					     	
	 					     	fout.write(instrs.elementAt(i).toString().getBytes());
	 					     	i++;
						     }
	 					     if(match == true) {
	 					     	String deadcode = "int m=0 ; " ;
	 					     	String deadcode1 = "m = m*n;";
	 					     	fout.write(deadcode.getBytes());
								fout.write(deadcode1.getBytes());
	 					     	flag =0;
	 					     }
	   				     }else fout.write(line.getBytes());
	 			   }
	 		  }
	          catch(Exception e) {
	 	          System.out.println("Exception is " + e);
	    	  }

	     }



	

   public static void copy(String inFile, String outFile)
         throws IOException {

          FileInputStream fin = null;
          FileOutputStream fout = null;

          try {
            fin  = new FileInputStream(inFile);
            fout = new FileOutputStream(outFile);
            StreamCopier(fin, fout);
          }
          finally {
            try {
              if (fin != null) fin.close();
            }
            catch (IOException e) {System.out.println("Exception " +e );}
            try {
              if (fout != null) fout.close();
             }
            catch (IOException e) { System.out.println("Exception " +e ); }
          }

        }

        public static void StreamCopier(InputStream in, OutputStream out)
           throws IOException {

            synchronized (in) {
              synchronized (out) {

                byte[] buffer = new byte[256];
                while (true) {
                  int bytesRead = in.read(buffer);
                  if (bytesRead == -1) break;
                  out.write(buffer, 0, bytesRead);
                }
              }
            }
        }
		  public static void convertToHTML(JavaClass clazz,String type)   throws java.io.IOException {

		   		   Class2HTML conObj = new Class2HTML(clazz,"C:/JHide/Obfuscated_Classes/HTMLFiles/" + type);


		   }





}