package algorithms;


import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;

import org.apache.bcel.classfile.*;
import org.apache.bcel.generic.*;
import org.apache.bcel.util.Class2HTML;

/**
@ Class: DataEncoding
@ Author: Suma Venkatesh
@ Description: This algorithm is one kind of data transformation where how data is interpreted is modified 
  the iteration space same.
*/


public class DataEncoding {
	 static FileInputStream fin;
	 static BufferedReader din;
	 static FileOutputStream fout;

	public boolean apply(JavaClass clazz) {

		ClassGen cgen = null;
		String classname = null;
		boolean sucess = false;
		

		try {
			cgen = new ClassGen(clazz);
			ConstantPoolGen cpg = cgen.getConstantPool();
			classname = clazz.getClassName();
			
			String outPath = "C:/JHide/engine/" + classname + ".java"; 

			encodeData(classname,outPath);

			JavaClass c = cgen.getJavaClass();

			//c.dump(new java.io.File("C:/JHide/Obfuscated_Classes/",c.getClassName().replace('.', java.io.File.separatorChar) + "_obf"+ ".class"));

			//convertToHTML(c,"Obf");
			sucess = true;

			System.out.println("Iam sucessful");

		 }
		 catch(Exception e) { //System.out.println("Exception : " + e);
		 					  return(sucess);
		 }
		return(sucess);
	 }

	 public static void encodeData(String fileName,String outName) {
	      
	 	try {

	 	          fin = new FileInputStream(fileName);
	 	          din = new BufferedReader(new InputStreamReader(fin));

	 	          File writeFileObj = new File(outName);
	 	          fout = new FileOutputStream(writeFileObj);
	 	          String line;
	 	          String replace = "int i = 8*i +1; ";
	 	          String replace1 = "while(i<8003) { ";
	 	          String replace2 = "A[(i-3)/8] = i;" + "i+=8; ";
	 	          boolean flag = true;

	 	          while ((line = din.readLine()) != null) {
	 	                 line= line.trim();

	 	                 boolean match = line.trim().regionMatches(true,0,"int",0,2);
	 	                 boolean match1 = line.trim().regionMatches(true,0,"while",0,4);
	 	                 boolean match2 = line.trim().regionMatches(true,0,"A[i]",0,3);
	 	                  System.out.println("match" + match + "match1" + match1 + "match2" + match2);

	 	                 if(match && flag) {
	 						 fout.write(replace.getBytes());
							 match = false;
							 flag = false;

	 				     }

						 else if(match1) {
							 fout.write(replace1.getBytes());
							 match1 = false;
					 	 }

						 else if(match2) {

							 fout.write(replace2.getBytes());
							 match2 = false;
					     }
					     else fout.write(line.getBytes());
	 			   }
	 		  }
	          catch(Exception e) {
	 	          //System.out.println("Exception is " + e);
	    	  }

	 }
	 public static void convertToHTML(JavaClass clazz,String type)   throws java.io.IOException {
	    Class2HTML conObj = new Class2HTML(clazz,"C:/JHide/Obfuscated_Classes/HTMLFiles/" + type);
	  }


}
	

   

