package algorithms;

import java.io.*;
import java.util.*;

import org.apache.bcel.classfile.JavaClass;
import org.apache.bcel.generic.ClassGen;
import org.apache.bcel.generic.ConstantPoolGen;

/**
@ Class: DataOrdering
@ Author: Suma Venkatesh
@ Description: This algorithm is one kind of Data transformation which affect how data is ordered
  
*/
public class DataOrdering {


	 static FileInputStream fin;
	 static BufferedReader din;
	 static FileOutputStream fout;


	 public boolean apply(JavaClass clazz) {

		ClassGen cgen = null;
		String classname = null;
		boolean sucess = false;
		

		try {
			cgen = new ClassGen(clazz);
			ConstantPoolGen cpg = cgen.getConstantPool();
			classname = clazz.getClassName();
			
			String outPath = "C:/JHide/engine/" + classname + ".java"; 

			ordering(classname,outPath);

			JavaClass c = cgen.getJavaClass();

			//c.dump(new java.io.File("C:/JHide/Obfuscated_Classes/",c.getClassName().replace('.', java.io.File.separatorChar) + "_obf"+ ".class"));

			//convertToHTML(c,"Obf");
			sucess = true;

			System.out.println("Iam sucessful");

		 }
		 catch(Exception e) { //System.out.println("Exception : " + e);
		 					  return(sucess);
		 }
		return(sucess);
	 }




  public void ordering(String fileName,String outName) throws IOException{
	  String line1 = null;
	  String line2 = null;
   	  try {

            fin = new FileInputStream(fileName);
            din = new BufferedReader(new InputStreamReader(fin));
            File writeFileObj = new File(outName);
            fout = new FileOutputStream(writeFileObj);

  	   	    String line;
  	   	    String var = "";

    	     while ((line = din.readLine()) != null) {
  			   line = line.trim();

			   if(line.equalsIgnoreCase("int i =1;")== true ) {
				   line1 =line;
				   line = " ";

		       }
  		       StringTokenizer st = new StringTokenizer(line);

  		       while (st.hasMoreTokens()) {
  						String token = st.nextToken();
  						System.out.println("token" +token);
  						if(token.trim().equalsIgnoreCase("A[i];")== true ) {
  						     token = "A[findPos()]";

				    	}
				    	else if(token.trim().equalsIgnoreCase("i") == true) {
							 token = "findPos()";
					    }
					    else if(token.trim().equalsIgnoreCase("i++;") == true) {
							line2 = token;
							token =" ";

					    }

				    	 fout.write(token.getBytes());
  		       }
     		 }
     		 String fun = " public int findPos() {";
			 fun = fun + line1 + line2 + "return(i); }";
			 fout.write(fun.getBytes());
			 fout.close();


  	    }

  	  catch(Exception e) {
  			          //System.out.println("Exception is " + e);
      }


  }


}
